final int WIDTH = 800;
final int HEIGHT = 800;
final float ERR = 0.125;
final int R = 200; //lunghezza braccio
final int r = 125; //lunghezza avambraccio

PVector P; //posizione del punto bersaglio
PVector G; //prima posizione possibile del giunto
PVector G1; //seconda posizione possibile

void setup() {
  size(WIDTH,HEIGHT);
  background(0);
  translate(WIDTH/2,HEIGHT/2); //cambiamento di coordinate
  G = new PVector(0, R);
  G1 = new PVector(0, R);
  P = new PVector(0, R+r);
  drawR();
  drawr();
}
void draw() {
  translate(WIDTH/2,HEIGHT/2); //cambiamento di coordinate
  background(0);
  float d=sqrt(sq(mouseX-WIDTH/2)+sq(mouseY-HEIGHT/2)); //calcola la distanza tra fulcro e punto beraglio
  if((mousePressed)&&((d>=abs(R-r))&&(d<=R+r))) { //verifica se, qualora sia premuto il mouse, il punto selezionato è raggiungibile
    P.x=mouseX-WIDTH/2; //salva le coordinate del punto
    P.y=mouseY-HEIGHT/2;
    
    /* 
    questa sezione è difficile da comprendere, si usa una formula che permette
    di individuare le coordinate del giunto intermedio nelle due possibili configurazioni
    */
    G.x = (P.x*(d*d+R*R-r*r)+P.y*sqrt(4*d*d*R*R-sq(d*d+R*R-r*r))) / (2*d*d);
    float Y1 = sqrt(R*R-G.x*G.x);
    float Y3 = P.y + sqrt(r*r-sq(G.x-P.x));
    float Y4 = P.y - sqrt(r*r-sq(G.x-P.x));
    if(((Y1<Y3+ERR)&&(Y1>Y3-ERR))||((Y1<Y4+ERR)&&(Y1>Y4-ERR)))
      G.y = Y1;
    else
      G.y = -Y1;
    G1.x = (P.x*(d*d+R*R-r*r)-P.y*sqrt(4*d*d*R*R-sq(d*d+R*R-r*r))) / (2*d*d);
    Y1 = sqrt(R*R-G1.x*G1.x);
    Y3 = P.y + sqrt(r*r-sq(G1.x-P.x));
    Y4 = P.y - sqrt(r*r-sq(G1.x-P.x));
    if(((Y1<Y3+ERR)&&(Y1>Y3-ERR))||((Y1<Y4+ERR)&&(Y1>Y4-ERR)))
      G1.y = Y1;
    else
      G1.y = -Y1;
  }
  
  //disegna i vari componenti del simulatore
  stroke(255);
  fill(0,0,255,100);
  ellipse(0,0,2*(R+r),2*(R+r));
  fill(0);
  ellipse(0,0,2*abs(R-r),2*abs(R-r));
  fill(255,0);
  ellipse(G.x,G.y,2*r,2*r);
  ellipse(G1.x,G1.y,2*r,2*r);
  ellipse(0,0,2*R,2*R);
  
  drawR();
  drawr();
  drawd();
}

void drawR() { //disegna il braccio
  strokeWeight(2);
  stroke(255,0,0);
  line(0,0,G.x,G.y);
  line(0,0,G1.x,G1.y);
}

void drawr() { //disegna l'avambraccio
  strokeWeight(2);
  stroke(0,255,0);
  line(G.x,G.y,P.x,P.y);
  line(G1.x,G1.y,P.x,P.y);
}

void drawd() { //disegna il segmento che congiunge fulcro e punto bersaglio
  strokeWeight(1);
  stroke(255);
  line(0,0,P.x,P.y);
}
